VERSION 5.00
Begin VB.Form frmLVExcelExportOptions 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Liste nach Microsoft Excel exportieren"
   ClientHeight    =   3240
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6420
   Icon            =   "frmLVExcelExportOptions.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3240
   ScaleWidth      =   6420
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'Fenstermitte
   Begin VB.Frame Frame1 
      Caption         =   "Exportziel"
      Height          =   855
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   6315
      Begin VB.CommandButton btnChangeFileName 
         Caption         =   "&ndern..."
         Height          =   315
         Left            =   4320
         TabIndex        =   3
         Top             =   180
         Width           =   1095
      End
      Begin VB.Label lblVersion 
         Height          =   255
         Left            =   2100
         TabIndex        =   5
         Top             =   540
         Width           =   2655
      End
      Begin VB.Image Image1 
         Height          =   720
         Left            =   5520
         Picture         =   "frmLVExcelExportOptions.frx":014A
         Top             =   120
         Width           =   720
      End
      Begin VB.Label Label3 
         Caption         =   "Installierte Excel-Version:"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   540
         Width           =   1875
      End
      Begin VB.Label lblFileName 
         Caption         =   "(nicht festgelegt)"
         Height          =   255
         Left            =   960
         TabIndex        =   2
         Top             =   240
         Width           =   3315
      End
      Begin VB.Label Label1 
         Caption         =   "Dateiname:"
         Height          =   255
         Left            =   120
         TabIndex        =   1
         Top             =   240
         Width           =   795
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Optionen"
      Height          =   1695
      Left            =   60
      TabIndex        =   6
      Top             =   1020
      Width           =   6315
      Begin VB.TextBox txtTitle 
         Height          =   315
         Left            =   540
         TabIndex        =   12
         Top             =   1260
         Width           =   4335
      End
      Begin VB.CheckBox chkOnlySelected 
         Caption         =   "Nur ausgewhlte Eintrge exportieren:"
         Height          =   315
         Left            =   120
         TabIndex        =   7
         Top             =   240
         Width           =   3015
      End
      Begin VB.CheckBox chkMark 
         Caption         =   "Ausgewhlte Eintrge hervorheben (Hintergrund)"
         Height          =   255
         Left            =   390
         TabIndex        =   10
         Top             =   900
         Width           =   4395
      End
      Begin VB.CheckBox chkBordersAndBackground 
         Caption         =   "Rahmen und farbige Hintergrnde exportieren"
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   600
         Value           =   1  'Aktiviert
         Width           =   4035
      End
      Begin VB.Label Label2 
         Caption         =   "Titel:"
         Height          =   255
         Left            =   120
         TabIndex        =   11
         Top             =   1320
         Width           =   555
      End
      Begin VB.Label lblSelectedItemCount 
         Caption         =   "0 Eintrge ausgewhlt"
         Height          =   255
         Left            =   3180
         TabIndex        =   8
         Top             =   300
         Width           =   2475
      End
   End
   Begin VB.CommandButton btnExport 
      Caption         =   "&Exportieren"
      Default         =   -1  'True
      Height          =   375
      Left            =   3780
      TabIndex        =   13
      Top             =   2820
      Width           =   1275
   End
   Begin VB.CommandButton btnCancel 
      Cancel          =   -1  'True
      Caption         =   "&Abbrechen"
      Height          =   375
      Left            =   5100
      TabIndex        =   14
      Top             =   2820
      Width           =   1275
   End
End
Attribute VB_Name = "frmLVExcelExportOptions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'==============================================================================
'Dialog zur Auswahl der Optionen fr den Export eines ListViews nach Excel.
'Wird mit ShowDlg() aufgerufen.
'
'Scope:     DLL-ffentlich erstellbar.
'==============================================================================

Option Explicit

Dim LVExporter As New clsLVExcelExport 'Klasse, die das Exportieren bernimmt

Dim mCancel As Boolean

'Startet Programme oder ffnet Dokumente
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

'==============================================================================
'Zweck:     ffentlich aufrufbare Funktion, die den Dialog anzeigt.
'
'Parameter: - ListView      Das zu exportierende ListView.
'           - Title         Titel des ListViews.
'
'Rckgabe:  True, falls der Dialog besttigt wurde, sonst False.
'==============================================================================
Function ShowDlg(ListView As ListView, ByVal Title As String) As Boolean
    LVExporter.ListView = ListView
    
    Dim selCount As Long, i As Long
    'Anzahl ausgewhlter Eintrge ermitteln
    For i = 1 To ListView.ListItems.Count
        If ListView.ListItems(i).Selected Then selCount = selCount + 1
    Next i
    
    lblSelectedItemCount.Caption = selCount & " " & IIf(selCount = 1, "Eintrag", "Eintrge") & " ausgewhlt"
    
    'Excel-Version ermitteln
    lblVersion.Caption = LVExporter.ExcelVersion
    
    LVExporter.Header = Title
    txtTitle.Text = Title
    
    Show 1
    
    If Not mCancel Then
        'Bei Besttigen des Dialogs, ListView exportieren.
        ShowDlg = True
        If LVExporter.ExportListViewToExcel Then
            If MsgBox("Liste wurde erfolgreich exportiert." & vbCrLf & vbCrLf & _
                "Mchten Sie die Datei gleich ffnen?", vbQuestion + vbYesNo, "Liste exportieren") = vbYes Then
                ShellExecute Me.hwnd, vbNullString, LVExporter.Filename, vbNullString, vbNullString, 1
            End If
        End If
    End If

    Unload Me
End Function

Private Sub btnCancel_Click()
    mCancel = True
    Me.Hide
End Sub

Private Sub btnExport_Click()
    If LVExporter.Filename = "" Then
        MsgBox "Kein Dateiname ausgewhlt.", vbCritical, "Liste exportieren"
    Else
        Hide
    End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If UnloadMode <> 1 Then
        btnCancel_Click
        Cancel = True
    End If
End Sub

Private Sub btnChangeFileName_Click()
    'Dateiauswahldialog anzeigen lassen
    If LVExporter.ShowFileDialog Then
        lblFileName.Caption = LVExporter.Filename
    End If
End Sub

Private Sub chkBordersAndBackground_Click()
    chkMark.Enabled = chkBordersAndBackground.value = 1
    LVExporter.BordersAndBackground = chkBordersAndBackground.value = 1
End Sub

Private Sub chkMark_Click()
    LVExporter.Mark = chkMark.value = 1
End Sub

Private Sub chkOnlySelected_Click()
    LVExporter.OnlySelected = chkOnlySelected.value = 1
End Sub

Private Sub txtTitle_Change()
    LVExporter.Header = txtTitle.Text
End Sub
